<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    
    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script type='text/javascript' src='https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js'></script>
    <title>Document</title>
    <style>
      .register-photo {
    background:#f1f7fc;
    padding:80px 0;
    display: flex;
  }
  
  .register-photo .image-holder {
    background-image: url(1.jpg);
    background-repeat: no-repeat;
    background-size: cover;
    flex: 40%;
   
  }
  
  .register-photo .form-container {
    display:flex;
    flex-direction: column;
    flex: 60%;
    margin:0 auto;
    box-shadow:1px 1px 5px rgba(0,0,0,0.1);
  }
  
  @media (max-width:991px) {
    .register-photo form {
      padding:40px;
    }
  }
  
  .register-photo form h2 {
    font-size:24px;
    line-height:1.5;
    margin-bottom:30px;
  }
  
  .register-photo form .form-control {
    background:#f7f9fc;
    border:none;
    border-bottom:1px solid #dfe7f1;
    border-radius:0;
    box-shadow:none;
    outline:none;
    color:inherit;
    text-indent:6px;
    height:40px;
  }
  
  .register-photo form .form-check {
    font-size:13px;
    line-height:20px;
  }
  
  .register-photo form .btn-primary {
    background:#f4476b;
    border:none;
    border-radius:4px;
    padding:11px;
    box-shadow:none;
    margin-top:35px;
    text-shadow:none;
    outline:none !important;
  }
  
  .register-photo form .btn-primary:hover, .register-photo form .btn-primary:active {
    background:#eb3b60;
  }
  
  .register-photo form .btn-primary:active {
    transform:translateY(1px);
  }
  
  .register-photo form .already {
    display:block;
    text-align:center;
    font-size:12px;
    color:#6f7a85;
    opacity:0.9;
    text-decoration:none;
  }
  h2{
    color:  #38D39F;
  }
 
  
    </style>
</head>
<body>
  <div class="register-photo">    
    <div class="form-container">
        <h2 class="text-center" >Contact us</h2>
        <br>
        <div class="form-group"> 
          <input type="text" id="inp-name" name="fullname" placeholder="Name" class="form-control"> 
        </div>
        <br>
        <div class="form-group"> 
          <input type="text" id="inp-email" name="email" placeholder="yourname@gmail.com" class="form-control"> 
        </div>
        <br>
        <div class="form-group">
          <textarea class="form-control" id="inp-contact" type="text"  placeholder="Write something"></textarea>
        </div>
        <br>
        <div class="form-group text-center">
          <button class="btn btn-success btn-block" type="submit" onclick="onBtnRegisterClick()" >
              Submit
          </button>
        </div>
    </div>
    <div class="image-holder"></div>  
  </div>            
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; //tạo đơn hàng thành công
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts"; 
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    function onBtnRegisterClick(){
      "use strict";
      console.log("Nút Register được ấn");
      //khai bao doi tuong chua du lieu register
      var vRegisterUserObject = {
        name: "",
        email: "",
        contact: "",
      }
      //b1 đọc dữ liệu
      readDataInput(vRegisterUserObject);
      //ghi ra console để xem đọc được chưa
      console.log(vRegisterUserObject);
      //b2 validate dữ liệu
      var vIsCheck = validateDataInput(vRegisterUserObject);
      //ghi ra console để xem kết quả kiểm tra
      console.log(vIsCheck);
      if(vIsCheck){
        //b3 gọi api send request
        var vXmlHttp = new XMLHttpRequest();
        callApiGetDataRegister(vXmlHttp,vRegisterUserObject);
        //b4 xử lý hiển thị sau khi request thành công
        vXmlHttp.onreadystatechange = function(){
          if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS){
            handleRegisterData(vXmlHttp);
          }
        }
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm đọc dữ liệu input từ web
    function readDataInput(paramRegisterObject){
      "use strict"
      //truy xuất id của từng input từ web
      var vInputFullNameElement = document.getElementById("inp-name");
      var vInputEmailElement = document.getElementById("inp-email");
      var vInputContactElement = document.getElementById("inp-contact");

      paramRegisterObject.name = vInputFullNameElement.value.trim();
      paramRegisterObject.email = vInputEmailElement.value.trim();
      paramRegisterObject.contact = vInputContactElement.value.trim();
      
    }

    function validateDataInput(paramRegisterObject){
      "use strict";
      //kiểm tra xem đã nhập full name chưa
      if(paramRegisterObject.name == ""){
        alert("Bạn cần nhập full name");
        return false;
      }
      //kiểm tra xem đã nhập email chưa
      if(paramRegisterObject.email == ""){
        alert("Bạn cần nhập email");
        return false;
      }
      //gọi hàm kiểm tra email
      var vKiemTraEmail = validateEmail(paramRegisterObject.email);
      if(!vKiemTraEmail){
        alert("Bạn cần nhập đúng định dạng");
        return false;
      }
      //kiểm tra xem nhập contact chưa
      if(paramRegisterObject.contact == ""){
        alert("Bạn cần nhập contact");
        return false;
      }
      return true;
    }
    //hàm kiểm tra email
    function validateEmail(paramEmail){
      var vFormatReg = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
      var vCheck = vFormatReg.test(paramEmail);
      return vCheck;
    }
    //call api send request
    function callApiGetDataRegister(paramXmlHttp,paramRegisterObject){
      "use strict";
      paramXmlHttp.open("POST",gBASE_URL_CONTACTS,true);
      paramXmlHttp.setRequestHeader("Content-Type","application/json;charset=UTF-8");
      paramXmlHttp.send(JSON.stringify(paramRegisterObject));
      console.log(paramRegisterObject);
    }
    //ham xu ly hien thi sau khi response thanh công
    function handleRegisterData(paramXmlHttp){
      "use strict";
      console.log(paramXmlHttp.responseText);
      alert("Tạo Contact user mới thành công");
      
    }

  </script>            
</body>
</html>